local addon_name, addon_data = ...
local debug = false

core_frame = CreateFrame("Frame", addon_name .. "CoreFrame", UIParent)
core_frame:RegisterEvent("ADDON_LOADED")

local function OnAddonLoaded(self)
    core_frame:SetScript("OnUpdate", CoreFrame_OnUpdate)
	core_frame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	core_frame:RegisterEvent("UPDATE_FACTION")
	core_frame:RegisterEvent("ZONE_CHANGED")
	core_frame:RegisterEvent("ZONE_CHANGED_INDOORS")
	core_frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	core_frame:RegisterEvent("UPDATE_INSTANCE_INFO")
	if debug then print("[|cff67BCFFdebug|r] OnAddonLoaded()") end
		--Used to determine the players faction.
	if UnitRace("player") == "Human" or "Night Elf" or "Gnome" or "Dwarf" then
		FactionIsAlliance = 1
		if debug then print("[|cff67BCFFdebug|r] Faction is Alliance") end
	else
		FactionIsHorde = 1
		if debug then print("[|cff67BCFFdebug|r] Faction Is Horde") end
	end
end

local function CoreFrame_OnEvent(self, event, ...)
	local args = {...}

   if event == "ADDON_LOADED" then
		if args[1] == "RepTracker" then
			OnAddonLoaded()
		end
	end

	if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
		if UnitOnTaxi("player") == false then
			GrabCurrentFactionValues()
			ZoneInstanceData()
			if debug then print("[|cff67BCFFdebug|r] CHAT_MSG_COMBAT_FACTION_CHANGE") end
			local CurrentZone = GetRealZoneText()
			local SubZone = GetSubZoneText()
			if debug then print("[|cff67BCFFdebug|r] "..CurrentZone.." is the CurrentZone") end
			if CurrentZone == "Stormwind City" then
				if SubZone == "Stormwind Keep" then
					-- Do nothing.
				else
					SetWatchedFactionIndex(StormwindRepID)
						if debug then print("[|cff67BCFFdebug|r] Stormwind in function CMCFC") end
					--if Ironforge ~= nil then
						local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(StormwindRepID)
					--else
					--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
					--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
			end
			if CurrentZone == "Winterspring" then
				if debug then print("[|cff67BCFFdebug|r] Winterspring in function CMCFC") end
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(TimbermawHoldRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Scholomance" then
				if debug then print("[|cff67BCFFdebug|r] Scholomance in function CMCFC") end
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(ArgentDawnRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Stratholme" then
				if debug then print("[|cff67BCFFdebug|r] Scholomance in function CMCFC") end
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(ArgentDawnRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Darnassus" then
				if debug then print("[|cff67BCFFdebug|r] Searing Gorge in function CMCFC") end
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(DarnassusRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Searing Gorge" then
				if debug then print("[|cff67BCFFdebug|r] Searing Gorge in function CMCFC") end
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(ThoriumBrotherhoodRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Silithus" then
				if debug then print("[|cff67BCFFdebug|r] Silithus in function CMCFC") end
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(CenarionCircleRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Zul'Gurub" then
				if debug then print("[|cff67BCFFdebug|r] Zul'Gurub in function CMCFC") end
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(ZandalarTribeRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Molten Core" then
				if debug then print("[|cff67BCFFdebug|r] Molten Core in function CMCFC") end
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(HydraxianWaterlordsRepID)
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Alterac Valley" then
				if debug then print("[|cff67BCFFdebug|r] Alterac Valley in function CMCFC") end
				--if StormpikeGuardRepID ~= nil then
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(StormpikeGuardRepID)
				--else
				--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(FrostwolfClanRepID)
				--end
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Arathi Basin" then
				if debug then print("[|cff67BCFFdebug|r] Arathi Basin in function CMCFC") end
				--if TheLeagueOfArathorRepID ~= nil then
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(TheLeagueOfArathorRepID)
				--else
				--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(TheDefilersRepID)
				--end
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Warsong Gulch" then
				if debug then print("[|cff67BCFFdebug|r] Warson Gulch in function CMCFC") end
				--if SilverwingSentinelsRepID ~= nil then
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(SilverwingSentinelsRepID)
				--else
				--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
				--end
				if standingId == 0 then -- Unknown
					--Skip
				elseif standingId == 1 then -- Hated
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
				elseif standingId == 2 then -- Hostile
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
				elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
				elseif standingId == 4 then -- Neutral
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
				elseif standingId == 5 then -- Friendly
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
				elseif standingId == 6 then -- Honored
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
				elseif standingId == 7 then -- Revered
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
				elseif standingId == 8 then -- Exalted
					print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
				end
			end
			if CurrentZone == "Ironforge" then
				if SubZone == "Tinker Town" then
					SetWatchedFactionIndex(GnomereganExilesRepId)
					if debug then print("[|cff67BCFFdebug|r] Gnomergan Exiles in function CMCFC") end
				--if Ironforge ~= nil then
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(GnomereganExilesRepId)
				--else
				--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
				--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				elseif SubZone == "Hall of Arms" then
					-- Do nothing.
				else
				SetWatchedFactionIndex(IronforgeRepID)
					if debug then print("[|cff67BCFFdebug|r] Ironforge in function CMCFC") end
					--if Ironforge ~= nil then
						local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(IronforgeRepID)
					--else
					--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
					--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
			end
			-- Something about being the bottom causes things to stop, this is just a bandaid
			-- Actual problem may lay elsewhere.
			if CurrentZone == "Nothing" then
			end
		end
	end
	if event == "UPDATE_FACTION" then
		if debug then print("[|cff67BCFFdebug|r] UPDATE_FACTION") end
		GrabCurrentFactionValues()
		ZoneInstanceData()
	end
	if event == "ZONE_CHANGED" then
		if debug then print("[|cff67BCFFdebug|r] ZONE_CHANGED") end
		GrabCurrentFactionValues()
		ZoneInstanceData()
	end
	if event == "UPDATE_INSTANCE_INFO" then
		if debug then print("[|cff67BCFFdebug|r] UPDATE_INSTANCE_INFO") end
		GrabCurrentFactionValues()
		ZoneInstanceData()
	end
	if event == "ZONE_CHANGED_INDOORS" then
		if debug then print("[|cff67BCFFdebug|r] ZONE_CHANGED_INDOORS") end
		GrabCurrentFactionValues()
		ZoneInstanceData()
	end
	if event == "ZONE_CHANGED_NEW_AREA" then
		if InBattleground == 1 then
			if debug then print("[|cff67BCFFdebug|r] ZONE_CHANGED_NEW_AREA") end
			GrabCurrentFactionValues()
			ZoneInstanceData()
		end
	end
end

function ZoneInstanceData()
	local CurrentZone = GetRealZoneText()
	local SubZone = GetSubZoneText()
	if UnitOnTaxi("player") == false then
		if debug then print(CurrentZone) end
		if CurrentZone == "Scholomance" then
			if debug then print("[|cff67BCFFdebug|r] Scholomance ZONE_CHANGED trigger") end
			local a = ArgentDawnRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Stratholme" then
			if debug then print("[|cff67BCFFdebug|r] Strat ZONE_CHANGED trigger") end
			local a = ArgentDawnRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Silithus" then
			if debug then print("[|cff67BCFFdebug|r] Silithus ZONE_CHANGED trigger") end
			local a = CenarionCircleRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Zul'Gurub" then
			if debug then print("[|cff67BCFFdebug|r] Zul'Gurub ZONE_CHANGED trigger") end
			local a = ZandalarTribeRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Molten Core" then
			if debug then print("[|cff67BCFFdebug|r] Molten Core ZONE_CHANGED trigger") end
			local a = HydraxianWaterlordsRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Alterac Valley" then
			if debug then print("[|cff67BCFFdebug|r] Alterac Valley ZONE_CHANGED trigger") end
			--if StormpikeGuardRepID ~= nil then
				local a = StormpikeGuardRepID
			--else
			--	local a = FrostwolfClanRepID
			--end
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Arathi Basin" then
			if debug then print("[|cff67BCFFdebug|r] Arathi Basin ZONE_CHANGED trigger") end
			--if TheLeagueOfArathorRepID ~= nil then
				local a = TheLeagueOfArathorRepID
			--else
			--	local a = TheDefilersRepID
			--end
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Warsong Gultch" then
			if debug then print("[|cff67BCFFdebug|r] Warsong Gulch ZONE_CHANGED trigger") end
			--if SilverwingSentinelsRepID ~= nil then
				local a = SilverwingSentinelsRepID
			--else
			--	local a = WarsongOutridersRepID
			--end
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Searing Gorge" then
			if debug then print("[|cff67BCFFdebug|r] Searing Gorge ZONE_CHANGED trigger") end
			--if SilverwingSentinelsRepID ~= nil then
				local a = ThoriumBrotherhoodRepID
			--else
			--	local a = WarsongOutridersRepID
			--end
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Winterspring" then
			if debug then print("[|cff67BCFFdebug|r] Winterspring ZONE_CHANGED trigger") end
			local a = TimbermawHoldRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Darnassus" then
			if debug then print("[|cff67BCFFdebug|r] Darnassus ZONE_CHANGED trigger") end
			local a = DarnassusRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Stormwind City" then
			if debug then print("[|cff67BCFFdebug|r] Stormwind City ZONE_CHANGED trigger") end
			local a = StormwindRepID
			local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
			local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
			SetWatchedFactionIndex(a)
			if factionID ~= factionID1 then
				if standingId <= 3 then
					print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
				elseif standingId == 4 then
					print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
				elseif standingId >= 5 then
					print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
				end
			end
		end
		if CurrentZone == "Ironforge" then
			if SubZone == "Hall of Arms" then
				-- Do nothing.
			elseif SubZone == "Tinker Town" then
				if debug then print("[|cff67BCFFdebug|r] Tinker Town ZONE_CHANGED trigger") end
				local a = GnomereganExilesRepId
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
				local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
				SetWatchedFactionIndex(a)
				if factionID ~= factionID1 then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			elseif SubZone ~= "Tinker Town" then
				if debug then print("[|cff67BCFFdebug|r] Ironforge ZONE_CHANGED trigger") end
				local a = IronforgeRepID
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(IronforgeRepID)
				local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
				SetWatchedFactionIndex(a)
				if factionID ~= factionID1 then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
		end
	end
end

function GrabCurrentFactionValues()
	local CurrentZone = GetRealZoneText()
	for factionIndex = 1, GetNumFactions() do
		local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(factionIndex)
		local name1, standing1, min1, max1, value1, factionID1 = GetWatchedFactionInfo()
		if name == "Cenarion Circle" then
			CenarionCircleRepID = factionIndex
		end
		if name == "Zandalar Tribe" then
			ZandalarTribeRepID = factionIndex
		end
		if name == "Hydraxian Waterlords" then
			HydraxianWaterlordsRepID = factionIndex
		end
		if name == "Thorium Brotherhood" then
			ThoriumBrotherhoodRepID = factionIndex
		--	if debug then print("ThoriumBrotherhoodRepID = "..ThoriumBrotherhoodRepID) end
		end
		if FactionIsAlliance then
			if debug then ChatFrame6:AddMessage("Alliance Faction check Passed in function GCFV") end
			if name == "Stormpike Guard" then
				StormpikeGuardRepID = factionIndex
			end
			if name == "The League of Arathor" then
				TheLeagueOfArathorRepID = factionIndex
			end
			if name == "Silverwing Sentinels" then
				SilverwingSentinelsRepID = factionIndex
			end
			if name == "Ironforge" then
				IronforgeRepID = factionIndex
			--	if debug then print("IronforgeRepID = "..IronforgeRepID) end
			end
			if name == "Darnassus" then
				DarnassusRepID = factionIndex
			end
			if name == "Gnomeregan Exiles" then
				GnomereganExilesRepId = factionIndex
			end
			if name == "Stormwind" then
				StormwindRepID = factionIndex
			end
		end
		if FactionIsHorde then
			if debug then ChatFrame6:AddMessage("Horde Faction check Passed in function GCFV") end
			if name == "The Defilers" then
				TheDefilersRepID = factionIndex
			end
			if name == "Frostwolf Clan" then
				FrostwolfClanRepID = factionIndex
			end
			if name == "Warsong Outriders" then
				WarsongOutridersRepID = factionIndex
			end
		end
		if name == "Timbermaw Hold" then
			TimbermawHoldRepID = factionIndex
		end
		if name == "Argent Dawn" then
			ArgentDawnRepID = factionIndex
		end
		if debug then ChatFrame5:AddMessage(name.. " is ID: "..factionIndex) end
	end
end

function InBattleground()
	local CurrentZone = GetRealZoneText()
	if CurrentZone == "Arathi Basin" or "Alterac Valley" or "Warsong Gultch" then
		return 1
	else
		return 0
	end
end

core_frame:SetScript("OnEvent", CoreFrame_OnEvent)